/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

void KbfxConfigDlgThemes::init()
{    
	img_nopreview=image3;
	connect( this, SIGNAL(KbfxThemeDoInstall(QString &)), this, SLOT(KbfxThemeInstall(QString &)) );
}

/*
void KbfxConfigDlgThemes::KbfxDudeAnimationButtonToggled( bool )
{
    if ( KbfxAnimationButton->state() == 2 )
    {
        KbfxAnimationButton->setText(tr2i18n("Animation is ON"));
        KbfxAnimationButton->setPaletteBackgroundColor(QColor (0,255,0));
        ConfigInit().m_SpinxDudeBlink=true;
    }
    if ( KbfxAnimationButton->state() == 0 )
    {
        KbfxAnimationButton->setText(tr2i18n("Animation is OFF"));
        KbfxAnimationButton->setPaletteBackgroundColor(QColor (221,223,228));
        ConfigInit().m_SpinxDudeBlink=false;
        
    }
	kdDebug()<<"SpinxDudeBlink State is:"<<ConfigInit().m_SpinxDudeBlink<<endl;
}
*/

void KbfxConfigDlgThemes::KbfxURLRequesterThemesPathUrlSelected( const QString & path)
{
	QString tmppath=path;
	if( tmppath.startsWith( "file://" ) )
	{
		tmppath.remove( "file://" );
	}
	if( !tmppath.endsWith( "/" ) )
	{
		tmppath.append( "/" );
	}
	
    QDir d(tmppath);
    d.setFilter( QDir::Dirs );
	if(!d.exists ())
	 	{
			kdDebug()<<"Themes folder does not exist - "<< tmppath <<endl;
			KMessageBox::error(0, tr2i18n("Invalid User Themes Folder!\nWill use Default User Themes Folder."), tr2i18n("Error Loading Themes"));
			tmppath=ConfigInit().m_UserSpinxThemeBasePathDefault;
		}
	
	KbfxURLRequesterThemesPath->setURL(tmppath);
	KbfxThemeList->clear();
	KbfxThemeList->insertStringList(KbfxThemesData().setThemeList(tmppath).keys());
	KbfxThemeList->setCurrentItem (0);
	ConfigInit().m_SpinxThemeName=KbfxThemeList->currentText();
	ConfigInit().m_SpinxThemeBasePath=KbfxThemesData().setThemeList(ConfigInit().m_UserSpinxThemeBasePath)[ConfigInit().m_SpinxThemeName];
	ConfigInit().m_UserSpinxThemeBasePath = tmppath;
	setKbfxThemePreview();
}





void KbfxConfigDlgThemes::KbfxThemeSelected( const QString & name)
{
	ConfigInit().m_SpinxThemeName=name;
	ConfigInit().m_SpinxThemeBasePath=KbfxThemesData().setThemeList(ConfigInit().m_UserSpinxThemeBasePath)[ConfigInit().m_SpinxThemeName];
	kdDebug()<<"Selected Theme is - "<< name <<endl;
	kdDebug()<<"Base Path - "<< ConfigInit().m_SpinxThemeBasePath <<endl;
	setKbfxThemePreview();
}

void KbfxConfigDlgThemes::setKbfxThemePreview()
{
	QString path=ConfigInit().m_SpinxThemeBasePath+ConfigInit().m_SpinxThemeName+"/preview.png";
	
	QImage tmp (path);
	if (tmp.isNull())
		{
			kdDebug()<<"No Preview Available for theme "<< ConfigInit().m_SpinxThemeName << endl;
//			QString default_path = locate ("data", "kbfx/images/nopreview.png");
			KbfxPixmapPreview->setPixmap(img_nopreview);
		}
	else
		{
			KbfxPixmapPreview->setPixmap(path);
		}
	
}


void KbfxConfigDlgThemes::ChangeForm()
{
	KbfxURLRequesterThemesPath->setURL(ConfigInit().m_UserSpinxThemeBasePath);
	KbfxThemeList->clear();
	
	KbfxThemeList->insertStringList(KbfxThemesData().setThemeList(ConfigInit().m_UserSpinxThemeBasePath).keys());
	kdDebug()<<"Theme Path is - "<< KbfxThemesData().setThemeList(ConfigInit().m_UserSpinxThemeBasePath)[ConfigInit().m_SpinxThemeName]<<endl;
	KbfxThemeList->setSelected (KbfxThemeList->findItem (ConfigInit().m_SpinxThemeName), TRUE);
	setKbfxThemePreview();
	
	KbfxDudeImage->setPixmap(ConfigInit().m_SpinxDudeImage);
	kdDebug()<<"Dude Image is - "<< ConfigInit().m_SpinxDudeImage <<endl;
	kdDebug()<<"Default Dude Image is - "<< ConfigInit().m_SpinxDudeImageDefault <<endl;

/*	
	if (ConfigInit().m_SpinxDudeBlink==TRUE && KbfxAnimationButton->state() == 0 )
	{
		KbfxAnimationButton->toggle();
	}
	if (ConfigInit().m_SpinxDudeBlink==FALSE && KbfxAnimationButton->state() == 2)
	{
		KbfxAnimationButton->toggle();
	}
*/
}




void KbfxConfigDlgThemes::KbfxDeleteThemeClicked()
{
    if( KMessageBox::warningContinueCancel( 0, tr2i18n( "<p>Are you sure you want to uninstall the KBFX theme <strong>%1</strong>?</p>" ).arg( ConfigInit().m_SpinxThemeName ), tr2i18n("Uninstall KBFX Theme"), tr2i18n("Uninstall") ) == KMessageBox::Cancel )
        return;
    
	kdDebug()<<"Deleting Theme - "<< ConfigInit().m_SpinxThemeName << " - " << ConfigInit().m_SpinxThemeBasePath+ConfigInit().m_SpinxThemeName <<endl;
    if( !KIO::NetAccess::del( ConfigInit().m_SpinxThemeBasePath+ConfigInit().m_SpinxThemeName, 0 ) ) 
    {
        KMessageBox::sorry( 0, tr2i18n( "<p>Could not uninstall this KBFX theme.</p>"
            "<p>You may not have sufficient permissions to delete the folder <strong>%1<strong></p>."
            ).arg( ConfigInit().m_SpinxThemeBasePath+ConfigInit().m_SpinxThemeName ) );
        return;
    }

    ChangeForm();
}




void KbfxConfigDlgThemes::KbfxInstallThemeClicked()
{
    KFileDialog KbfxInstallDialog( QString::null, "*.tar *.tar.bz2 *.tar.gz *.kbfxtheme|" + tr2i18n( "KBFX Theme Packages (*.tar, *.tar.bz2, *.tar.gz, *.kbfxtheme)" ), 0, 0, TRUE );
    KbfxInstallDialog.setCaption( tr2i18n( "Select KBFX Theme Package To Install" ) );
    KbfxInstallDialog.setMode( KFile::File | KFile::ExistingOnly );
    if ( !KbfxInstallDialog.exec() ) return;

    KbfxInstallDialogURL=KbfxInstallDialog.selectedURL().path();
    emit KbfxThemeDoInstall( KbfxInstallDialogURL );
}

void KbfxConfigDlgThemes::KbfxThemeInstall(QString & installUrl)
{
    KTar KbfxThemeArchive( installUrl );

    if ( !KbfxThemeArchive.open( IO_ReadOnly ) ) {
        KMessageBox::sorry( 0, tr2i18n( "Could not read this KBFX Theme Package." ) );
        kdDebug()<<"Error reading archive "<< installUrl <<endl;
        return;
    }

    const QString KbfxThemeDestination = KGlobal::dirs()->saveLocation( "data", QString("kbfx/skins/"), TRUE );
	kdDebug()<<"Copying Theme to - "<< KbfxThemeDestination <<endl;
    const KArchiveDirectory* KbfxThemeArchiveDir = KbfxThemeArchive.directory();
    KbfxThemeArchiveDir->copyTo( KbfxThemeDestination, TRUE );
    ChangeForm();
}

void KbfxConfigDlgThemes::KbfxSelectDudeImageClicked()
{
    KFileDialog KbfxDudeImageDialog( QString::null, "image/jpeg image/png image/x-xpm image/gif ", 0, 0, TRUE );
    KbfxDudeImageDialog.setCaption( tr2i18n( "Select Personal Image" ) );
    KbfxDudeImageDialog.setMode( KFile::File | KFile::ExistingOnly );
    if ( !KbfxDudeImageDialog.exec() ) return;
    
    ConfigInit().m_SpinxDudeImage=KbfxDudeImageDialog.selectedURL().path();
    QImage tmp (ConfigInit().m_SpinxDudeImage);
	if (tmp.isNull ())
		{
			KMessageBox::error(0, tr2i18n("Image cannot be used as a Personal Image!\nWill use Default Personal Image."), tr2i18n("Error Loading Image"));
			ConfigInit().m_SpinxDudeImage=ConfigInit().m_SpinxDudeImageDefault;
		}
    
    KbfxDudeImage->setPixmap(ConfigInit().m_SpinxDudeImage);
	kdDebug()<<"Dude Image is changed to - "<< ConfigInit().m_SpinxDudeImage <<endl;
}


